// OGLESQuery.hpp
// KlayGE OpenGL ESڵ ʵļ
// Ver 3.0.0
// Ȩ(C) , 2005
// Homepage: http://www.klayge.org
//
// 3.0.0
// ν (2005.9.27)
//
// ޸ļ¼
//////////////////////////////////////////////////////////////////////////////////

#ifndef _OGLESQUERY_HPP
#define _OGLESQUERY_HPP

#pragma once

#include <KlayGE/Query.hpp>

namespace KlayGE
{
	class OGLESConditionalRender : public ConditionalRender
	{
	public:
		OGLESConditionalRender();
		~OGLESConditionalRender();

		void Begin();
		void End();

		void BeginConditionalRender();
		void EndConditionalRender();

		bool AnySamplesPassed();

	private:
		GLuint query_;
	};

	class OGLESTimerQuery : public TimerQuery
	{
	public:
		OGLESTimerQuery();
		~OGLESTimerQuery();

		void Begin();
		void End();

		double TimeElapsed();

	private:
		GLuint query_;
	};

	class OGLESSOStatisticsQuery : public SOStatisticsQuery
	{
	public:
		OGLESSOStatisticsQuery();
		~OGLESSOStatisticsQuery();

		void Begin();
		void End();

		uint64_t NumPrimitivesWritten() override;
		uint64_t PrimitivesGenerated() override;

	private:
		GLuint primitive_written_query_;
		GLuint primitive_generated_query_;
	};
}

#endif		// _OGLQUERY_HPP
